from pbkdf2 import PBKDF2
from error import *
import os
import io

username = None
key = None
IV = None
master = {}

def genKey():
    return PBKDF2(os.urandom(32), '').read(16)

def _readKeys(filename):
    global key,username
    keys = {}
    if os.path.isfile(filename):
        data = io.read(filename,key)
        csum, perms, contents = io.parse(data)
        lines = contents.split('\n')
        if lines[0] == username:
            for line in lines[1:]:
                if line:
                    fname,k,csum = line.split()
                    keys[fname] = (k.decode('hex'),csum)
    return keys

def writeKeys(key):
    global master,username
    filename = io.getEncName(username+'.master', key)
    content = username + '\n'
    for k, val in master.iteritems():
        content += "%s %s %s\n"%(k, val[0].encode('hex'), val[1])
    content += "%s %s %s\n"%(filename, key.encode('hex'), 1)
    content += "%s %s %s\n"%(username+'.master', key.encode('hex'), 1)
    io.write(filename, io.format('','',content), key)

def login(args):
    if len(args) != 2:
        raise CommandError("Usage: login username password")

    global username, key, IV, master
    if username:
        raise CommandError("Already logged in.")
    username = args[0]
    key = PBKDF2(args[1], '').read(16)
    IV = PBKDF2('SECRETIV', '').read(16)

    filename = io.getEncName(username+'.master', key)
    master = _readKeys(filename)

def logout(args):
    if len(args) != 0:
        raise CommandError("Usage: logout")

    global username, key, IV, master
    if not username:
        raise CommandError("Not logged in.")

    writeKeys(key)

    username = None
    key = None
    IV = None
    master = {}
